import java.awt.Image;
import java.io.IOException;
import javax.imageio.*;

class MarisaReimu extends HybridBody<Reimu, Marisa> implements java.io.Serializable
{
	static final long serialVersionUID = 1L;
	public static final int type = 10000;
	public static final String nameJ = "???";
	public static final String nameE = "Reimu";
	
	private static Image[][][] images = new Image[17][2][3];
	
	public static void loadImages (ClassLoader loader) throws IOException
	{
		final String dir = "images/hybrid/marisa-reimu/";
		
		images[ImgFlag.STANDARD][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"standard_left.png"));
		images[ImgFlag.SHIT][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"shit.png"));
		images[ImgFlag.WANT_REFRESH][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"want-refresh_left.png"));
		images[ImgFlag.SLEEPING][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"sleeping_left.png"));
		images[ImgFlag.DEAD][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"dead_left.png"));
		images[ImgFlag.INJURED][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"injured_left.png"));
		images[ImgFlag.PUFF][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"puff_left.png"));
		images[ImgFlag.CRYING][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"crying_left.png"));
		images[ImgFlag.NO_ACCESSORY][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"no-accessory_left.png"));
		images[ImgFlag.NO_ACCESSORY_INJURED][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"no-accessory-injured_left.png"));
		images[ImgFlag.NO_ACCESSORY_DEAD][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"no-accessory-dead_left.png"));
		images[ImgFlag.ROLL][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"roll_left.png"));
		images[ImgFlag.LICK][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"lick_left.png"));
		images[ImgFlag.REFRESHED][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"refreshed_left.png"));
		images[ImgFlag.CRUSHED][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"crushed.png"));
		images[ImgFlag.LICK_INJURED][ImgFlag.LEFT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"lick-injured_left.png"));
		
		images[ImgFlag.STANDARD][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"standard_right.png"));
		images[ImgFlag.SHIT][ImgFlag.RIGHT][adultIndex] = null;
		images[ImgFlag.WANT_REFRESH][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"want-refresh_right.png"));
		images[ImgFlag.SLEEPING][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"sleeping_right.png"));
		images[ImgFlag.DEAD][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"dead_right.png"));
		images[ImgFlag.INJURED][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"injured_right.png"));
		images[ImgFlag.PUFF][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"puff_right.png"));
		images[ImgFlag.CRYING][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"crying_right.png"));
		images[ImgFlag.NO_ACCESSORY][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"no-accessory_right.png"));
		images[ImgFlag.NO_ACCESSORY_INJURED][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"no-accessory-injured_right.png"));
		images[ImgFlag.NO_ACCESSORY_DEAD][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"no-accessory-dead_right.png"));
		images[ImgFlag.ROLL][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"roll_right.png"));
		images[ImgFlag.LICK][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"lick_right.png"));
		images[ImgFlag.REFRESHED][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"refreshed_right.png"));
		images[ImgFlag.CRUSHED][ImgFlag.RIGHT][adultIndex] = null;
		images[ImgFlag.LICK_INJURED][ImgFlag.RIGHT][adultIndex] = ImageIO.read(loader.getResourceAsStream(dir+"lick-injured_right.png"));
		
		for(Image[][] array2d : images)
		{	
			for(Image[] array : array2d)
			{
				if(array[adultIndex] == null) { continue; }
				// Scale larger images down for koyukkuri
				array[babyIndex] = array[adultIndex].getScaledInstance(babyWidth, babyHeight, Image.SCALE_AREA_AVERAGING);
				array[childIndex] = array[adultIndex].getScaledInstance(childWidth, childHeight, Image.SCALE_AREA_AVERAGING);
			}
		}
	}
	
	public Image getImage (int type, int direction, AgeState age) { return images[type][direction][age.ordinal()]; }
	
	@Override
	public int getType () { return type; }
	
	@Override
	public String getNameJ () { return nameJ; }
	
	@Override
	public String getNameE () { return nameE; }
	
	@Override
	public MarisaReimu clone () { return new MarisaReimu(this); }
	
	@Override
	protected String [] msgWantFoodJ () {
		String[] output = {"???????????????", "???????????????", "?????????????"};
		return output;
	}
	
	@Override
	protected String [] msgWantFoodE () {
		String[] output = {"The shmell of mishder food!", "Shmell of mishder food!", "It's the smell of mister food!"};
		return output;
	}
	
	@Override
	protected String[][] msgNoFoodJ()
	{
		String[][] output = {{"??????????!", "??????????????????????", "??????????????????"},
									{"?????????????", "?????????????", "?????????????????"}};
		return output;
	}
	
	@Override
	protected String[][] msgNoFoodE()
	{
		String[][] output = {{"Mishder food ish nod here!", "Mishder food ish nod here! Are you shtoopid?  Wand choo die?", "Mister food is not here?  Are you stupid? Want to die?"},
									{"Gib back mishder food...", "Gib back mishder food...", "Pwease give back mister food..."}};
		return output;
	}
	
	@Override
	protected String msgExciteJ() { return "?????????!"; }
	
	@Override
	protected String msgExciteE() { return "Want to refresh~!"; }
	
	@Override
	protected String[] msgRelaxJ()
	{
		String output[] = {"????????????!", "????????????!", "??????????!"};
		return output;
	}
	
	@Override
	protected String[] msgRelaxE()
	{
		String output[] = {"Chake id eajy!", "Chake id eajy!", "Take it easy!"};
		return output;
	}
	
	@Override
	protected String[] msgFuriFuriJ()
	{
		String output[] = {"??????", "???????????????!", "?????????????????!"};
		return output;
	}
	
	@Override
	protected String[] msgFuriFuriE()
	{
		String output[] = {"Relax-relax~", "Maricha ish showwy for being sho cude!", "Taste Marisa's anyaru is ok too!"};
		return output;
	}
	
	protected String[] msgWakeupJ()
	{
		String output[] = {"????????????!", "????????????!", "??????????!"};
		return output;
	}
	
	protected String[] msgWakeupE()
	{
		String output[] = {"Chake id eajy!", "Chake id eajy!", "Take it easy!"};
		return output;
	}
	
	@Override
	protected String msgSleepJ() { return "??????"; }
	
	@Override
	protected String msgSleepE() { return "Sleep-Sleep---"; }
	
	@Override
	protected String[][] msgScreamJ() {
		String[][] output = {{"????!", "????!???????!", "???!?????!"},
									{"????????????", "????????????????", "????????????????????"}};
		return output;
	}
	
	@Override
	protected String[][] msgScreamE() {
		String[][] output = {{"YUNYA-!!", "ID HURD!  Going choo pyuff-pyuff!", "It hurts! Puff!!"},
									{"Shdop id shdop id-", "Maricha ish showwy sho pwease shdop id...", "Why would you do thisss...."}};
		return output;
	}
	
	@Override
	protected String[][] msgScareJ () {
		String[][] output = {{"????!", "??????????!", "?????????????!"},
									{"????????????", "????????????????", "????????????????????"}};
		return output;
	}
	
	@Override
	protected String[][] msgScareE () {
		String[][] output = {{"YUNYA-!!", "I can'ch chake id eajy!", "I feel like I can't take it easy!"},
									{"Shdop id shdop id-", "Maricha ish showwy sho pwease shdop id...", "Why would you do thisss...."}};
		return output;
	}
	
	@Override
	protected String[][] msgAlarmJ () {
		String[][] output = {{"??????????????!", "??????????????!", "?????????????!"},
									{"????????????", "????????????????", "????????????????????"}};
		return output;
	}
	
	@Override
	protected String[][] msgAlarmE () {
		String[][] output = {{"I can'ch chake id eajy!", "I can'ch chake id eajy!", "I feel like I can't take it easy!"},
									{"Shdop id shdop id-", "Maricha ish showwy sho pwease shdop id...", "Why would you do thisss...."}};
		return output;
	}
	
	@Override
	protected String[] msgDyingJ () {
		String[] output = {"???!", "????!", "???!"};
		return output;
	}
	
	@Override
	protected String[] msgDyingE () {
		String[] output = {"Yubee!!", "Puff!", "Blarg!"};
		return output;
	}
	
	@Override
	protected String[] msgDeadJ () {
		String[] output = {"?????????????????", "?????????????????", "???????????????"};
		return output;
	}
	
	@Override
	protected String[] msgDeadE () {
		String[] output = {"Wanted choo chake id eajy more...", "Wanted choo chake id eajy more...", "Wanted to take it easy more..."};
		return output;
	}
	
	@Override
	protected String[][] msgEatingJ () {
		String[][] output = {{"???????????????", "???????????????", "??????????????"},
									{"???????????", "???????????", "????????????"}};
		return output;
	}
	
	@Override
	protected String[][] msgEatingE () {
		String[][] output = {{"Myunch-Myunch, happinesh~ ", "Myunch~ Myunch~ Happinesh~", "Munch munch, Happiness"},
									{"Myunch myunch...", "Myunch Myunch, nom nom", "Munch munch, so good!"}};
		return output;
	}
	
	@Override
	protected String[] msgEatingShitJ () {
		String[] output = {"??????????????????", "?????????????????", "????????????????"};
		return output;
	}
	
	@Override
	protected String[] msgEatingShitE () {
		String[] output = {"Myunch-Myunch, disgusting...", "Myunch~ Myunch~ disgusting...", "Munch munch, disgusting..."};
		return output;
	}
	
	@Override
	protected String[] msgFullJ () {
		String[] output = {"???????????", "???????????", "????????????"};
		return output;
	}
	
	@Override
	protected String[] msgFullE () {
		String[] output = {"Tummy ish full...", "Tummy ish full...", "Can't eat anymore..."};
		return output;
	}
	
	@Override
	protected String[][] msgHealingJ () {
		String[][] output = {{"??????!", "?????????!", "???????!"},
									{"??????", "?????????", "???????"}};
		return output;
	}
	
	@Override
	protected String[][] msgHealingE () {
		String[][] output = {{"Shweet-shweet!", "Eajy!", "Can take it easy!"},
									{"Shweet-shweet", "Can chake id eajy", "Can take it easy"}};
		return output;
	}
	
	@Override
	protected String[] msgSukkiriJ () {
		String[] output = {"?????!", "?????!", "????!"};
		return output;
	}
	
	@Override
	protected String[] msgSukkiriE () {
		String[] output = {"Wefweshed!", "Wefeshed!", "Refreshed!"};
		return output;
	}
	
	@Override
	protected String msgBirthJ () { return "???????????!"; }
	
	@Override
	protected String msgBirthE () { return "Mawicha ish Weimu! Chake id eajy!"; }
	
	@Override
	protected String[] msgShitJ () {
		String[] output = {"????????!", "????????????????????????????!", "????????????????????!"};
		return output;
	}
	
	@Override
	protected String[] msgShitE () {
		String[] output = {"Poo-pooing!", "Maricha's shuupa poo-poo time ish shtarting!", "Marisa's super poo-poo time is starting!"};
		return output;
	}
	
	@Override
	protected String[] msgShit2J () {
		String[] output = {"????!", "?????!", "?????!"};
		return output;
	}
	
	@Override
	protected String[] msgShit2E () {
		String[] output = {"Wefeshed!", "Wefeshed-!!", "Refreshed~!"};
		return output;
	}
	
	@Override
	protected String[] msgSuriSuriJ () {
		String[] output = {"??????", "????????", "??????"};
		return output;
	}
	
	@Override
	protected String[] msgSuriSuriE () {
		String[] output = {"Wub-wub", "Wub-wub", "Rub-rub"};
		return output;
	}
	
	@Override
	protected String[] msgPeroPeroJ () {
		String[] output = {"??????", "????????", "??????"};
		return output;
	}
	
	@Override
	protected String[] msgPeroPeroE () {
		String[] output = {"Wick-wick~", "Wick-wick~", "Lick-lick~"};
		return output;
	}
	
	@Override
	protected String msgBreedJ () { return "?????????"; }
	
	@Override
	protected String msgBreedE () { return "B...Being born..."; }
	
	@Override
	protected String msgBreed2J () { return "??????????!"; }
	
	@Override
	protected String msgBreed2E () { return "Take it easy!"; }
	
	@Override
	protected String[][] msgHateShitJ () {
		String[][] output = {{"?????!", "????????!?????????????!", "??????????!??????!"},
									{"???????", "???????????????????", "?????????????????"}};
		return output;
	}
	
	@Override
	protected String[][] msgHateShitE () {
		String[][] output = {{"Shmelly~!", "Poo-poo shdinky!!  Help eajy!!", "Hurry up and save me from poo-poo!! Right now is fine!"},
									{"Shmelly...", "Shmelly, can'ch chake id eajy...", "Smelly... can't take it easy..."}};
		return output;
	}
	
	@Override
	protected String[][] msgHungryJ () {
		String[][] output = {{"????????????!", "???????????????????!", "????????????????!????????!"},
									{"??????????", "?????????????", "????????????"}};
		return output;
	}
	
	@Override
	protected String[][] msgHungryE () {
		String[][] output = {{"Gib up shweet-shweets!", "Bwing mishder munch-munch choo Mawicha!", "Bring the munch-munch to Marisa! A lot is fine!"},
									{"Where ish mishder food?", "Misder tummy ish hungwy...", "Pwease give Bawiza some food..."}};
		return output;
	}
	
	@Override
	protected String[] msgNoAccessoryJ () {
		String[] output = {"????!???????????", "????!?????????????????????", "?????????????"};
		return output;
	}
	
	@Override
	protected String[] msgNoAccessoryE () {
		String[] output = {"Yunn~!  Where ish misder Wibbon?", "Yunn~!  Where ish Mawicha's cude-cude misder Wibbon?", "Where's Marisa's mister ribbon?"};
		return output;
	}
	
	@Override
	protected String[] msgHateYukkuriJ () {
		String[] output = {"??????????????????", "??????????????????", "????????????????!????????!"};
		return output;
	}
	
	@Override
	protected String[] msgHateYukkuriE () {
		String[] output = {"There'sh a yukkuri that can'ch chake id eajy", "There'sh a yukkuri that can'ch chake id eajy", "A yukkuri that can't take it easy!  Punishment time!"};
		return output;
	}
	
	@Override
	protected String[] msgFlyingJ () {
		String[] output = {"??????????????!", "????????????????!", "???????????!"};
		return output;
	}
	
	@Override
	protected String[] msgFlyingE () {
		String[] output = {"Ich feewsh wike fwying!", "Mawicha ish mishter flying bird!", "I feel like I'm flying!"};
		return output;
	}
	
	@Override
	protected String msgSadnessForChildJ () { return "????????????????????????!"; }
	
	@Override
	protected String msgSadnessForChildE () { return "Open your beautiful clear eyes, my little one!"; }
	
	@Override
	protected String msgSadnessForPartnerJ (Body partner) {
		return partner.getNameJ()+"??????!";
	}
	
	@Override
	protected String msgSadnessForPartnerE (Body partner) {
		return "Open your eyes, "+partner.getNameE()+"!";
	}

	// public methods
	public MarisaReimu(int initX, int initY, int initZ, Body.AgeState initAgeState, Body p1, Body p2) {
		super(initX, initY, initZ, initAgeState, p1, p2);
	}
	
	protected MarisaReimu (MarisaReimu other) { super(other); }
}